Index: /branches/HeuristicLab.MetaOptimization/HeuristicLab.HiveEngine.Views/3.3/HiveEngineView.Designer.cs
===================================================================
--- /branches/HeuristicLab.MetaOptimization/HeuristicLab.HiveEngine.Views/3.3/HiveEngineView.Designer.cs	(revision 12929)
+++ /branches/HeuristicLab.MetaOptimization/HeuristicLab.HiveEngine.Views/3.3/HiveEngineView.Designer.cs	(revision 12930)
@@ -38,5 +38,4 @@
       this.executionTimeLabel = new System.Windows.Forms.Label();
       this.executionTimeTextBox = new System.Windows.Forms.TextBox();
-      this.isPrivilegedCheckBox = new System.Windows.Forms.CheckBox();
       this.tabControl.SuspendLayout();
       this.jobsTabPage.SuspendLayout();
@@ -55,10 +54,10 @@
       // resourceIdsTextBox
       // 
-      this.resourceIdsTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.resourceIdsTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.resourceIdsTextBox.Location = new System.Drawing.Point(189, 52);
       this.resourceIdsTextBox.Name = "resourceIdsTextBox";
-      this.resourceIdsTextBox.Size = new System.Drawing.Size(428, 20);
+      this.resourceIdsTextBox.Size = new System.Drawing.Size(517, 20);
       this.resourceIdsTextBox.TabIndex = 4;
       this.resourceIdsTextBox.Text = "HEAL";
@@ -94,7 +93,7 @@
       // executionTimeOnHiveTextBox
       // 
-      this.executionTimeOnHiveTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.executionTimeOnHiveTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.executionTimeOnHiveTextBox.Location = new System.Drawing.Point(129, 26);
       this.executionTimeOnHiveTextBox.Name = "executionTimeOnHiveTextBox";
@@ -105,7 +104,7 @@
       // tabControl
       // 
-      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.tabControl.Controls.Add(this.jobsTabPage);
       this.tabControl.Controls.Add(this.logTabPage);
@@ -135,4 +134,5 @@
       this.hiveExperimentListView.Name = "hiveExperimentListView";
       this.hiveExperimentListView.ReadOnly = false;
+      this.hiveExperimentListView.ShowDetails = true;
       this.hiveExperimentListView.Size = new System.Drawing.Size(686, 428);
       this.hiveExperimentListView.TabIndex = 0;
@@ -171,7 +171,7 @@
       // executionTimeTextBox
       // 
-      this.executionTimeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.executionTimeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.executionTimeTextBox.Location = new System.Drawing.Point(129, 3);
       this.executionTimeTextBox.Name = "executionTimeTextBox";
@@ -180,21 +180,8 @@
       this.executionTimeTextBox.TabIndex = 11;
       // 
-      // isPrivilegedCheckBox
-      // 
-      this.isPrivilegedCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.isPrivilegedCheckBox.AutoSize = true;
-      this.isPrivilegedCheckBox.Location = new System.Drawing.Point(623, 54);
-      this.isPrivilegedCheckBox.Name = "isPrivilegedCheckBox";
-      this.isPrivilegedCheckBox.Size = new System.Drawing.Size(80, 17);
-      this.isPrivilegedCheckBox.TabIndex = 13;
-      this.isPrivilegedCheckBox.Text = "IsPrivileged";
-      this.isPrivilegedCheckBox.UseVisualStyleBackColor = true;
-      this.isPrivilegedCheckBox.Validated += new System.EventHandler(this.isPrivilegedCheckBox_Validated);
-      // 
       // HiveEngineView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.isPrivilegedCheckBox);
       this.Controls.Add(this.executionTimeTextBox);
       this.Controls.Add(this.executionTimeLabel);
@@ -231,5 +218,4 @@
     private HeuristicLab.Core.Views.LogView logView;
     private RefreshableHiveJobListView hiveExperimentListView;
-    private System.Windows.Forms.CheckBox isPrivilegedCheckBox;
   }
 }
Index: /branches/HeuristicLab.MetaOptimization/HeuristicLab.HiveEngine.Views/3.3/HiveEngineView.cs
===================================================================
--- /branches/HeuristicLab.MetaOptimization/HeuristicLab.HiveEngine.Views/3.3/HiveEngineView.cs	(revision 12929)
+++ /branches/HeuristicLab.MetaOptimization/HeuristicLab.HiveEngine.Views/3.3/HiveEngineView.cs	(revision 12930)
@@ -73,5 +73,4 @@
         priorityTextBox.Text = string.Empty;
         executionTimeOnHiveTextBox.Text = string.Empty;
-        isPrivilegedCheckBox.Checked = false;
         hiveExperimentListView.Content = null;
         logView.Content = null;
@@ -80,5 +79,4 @@
         priorityTextBox.Text = Content.Priority.ToString();
         executionTimeOnHiveTextBox.Text = Content.ExecutionTimeOnHive.ToString();
-        isPrivilegedCheckBox.Checked = Content.IsPrivileged;
         hiveExperimentListView.Content = Content.Jobs;
         logView.Content = Content.Log;
@@ -92,9 +90,7 @@
         resourceIdsTextBox.ReadOnly = this.ReadOnly;
         priorityTextBox.ReadOnly = this.ReadOnly;
-        isPrivilegedCheckBox.Enabled = Content.IsAllowedPrivileged;
       } else {
         resourceIdsTextBox.ReadOnly = false;
         priorityTextBox.ReadOnly = false;
-        isPrivilegedCheckBox.Enabled = false;
       }
     }
@@ -108,8 +104,4 @@
       Content.Priority = int.Parse(priorityTextBox.Text);
     }
-
-    private void isPrivilegedCheckBox_Validated(object sender, EventArgs e) {
-      Content.IsPrivileged = isPrivilegedCheckBox.Checked;
-    }
     #endregion
   }
Index: /branches/HeuristicLab.MetaOptimization/HeuristicLab.HiveEngine/3.3/HiveEngine.cs
===================================================================
--- /branches/HeuristicLab.MetaOptimization/HeuristicLab.HiveEngine/3.3/HiveEngine.cs	(revision 12929)
+++ /branches/HeuristicLab.MetaOptimization/HeuristicLab.HiveEngine/3.3/HiveEngine.cs	(revision 12930)
@@ -92,6 +92,4 @@
     }
 
-    public bool IsAllowedPrivileged { get; set; }
-
     #region constructors and cloning
     public HiveEngine() {
@@ -99,5 +97,4 @@
       this.Priority = 0;
       this.log = new ThreadSafeLog();
-      this.IsAllowedPrivileged = HiveServiceLocator.Instance.CallHiveService((s) => s.IsAllowedPrivileged());
     }
 
@@ -288,5 +285,6 @@
         log.LogException(e);
         throw e;
-      } finally {
+      }
+      finally {
         DisposeJob(refreshableJob);
       }
@@ -299,5 +297,4 @@
         hiveExperiment.DateCreated = DateTime.Now;
         hiveExperiment.ResourceNames = this.ResourceNames;
-        hiveExperiment.IsPrivileged = this.IsPrivileged;
         var refreshableHiveExperiment = new RefreshableJob(hiveExperiment);
         refreshableHiveExperiment.IsDownloadable = false; // download happens automatically so disable button