Index: branches/crossvalidation-2434/HeuristicLab.Services.WebApp.Status/3.3/WebApp/history/history.cshtml
===================================================================
--- branches/crossvalidation-2434/HeuristicLab.Services.WebApp.Status/3.3/WebApp/history/history.cshtml	(revision 12779)
+++ branches/crossvalidation-2434/HeuristicLab.Services.WebApp.Status/3.3/WebApp/history/history.cshtml	(revision 12931)
@@ -15,5 +15,5 @@
             <label for="fromDate">From:&nbsp;</label>
             <div class="input-group">
-                <input id="fromDate" type="text" class="form-control" datepicker-popup="dd.MM.yyyy" ng-model="fromDate" is-open="fromIsOpen" datepicker-options="dateOptions" ng-required="true" close-text="Close" />
+                <input id="fromDate" type="text" class="form-control" datepicker-popup="dd.MM.yyyy" ng-model="fromDate" is-open="fromIsOpen" datepicker-options="dateOptions" ng-required="true" close-text="Close"/>
                 <span class="input-group-btn">
                     <button type="button" class="btn btn-default" ng-click="openFromDateSelection($event)"><i class="glyphicon glyphicon-calendar"></i></button>
@@ -32,11 +32,11 @@
         <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
             <div class="btn-group" dropdown dropdown-append-to-body>
-                <button type="button" class="btn btn-default dropdown-toggle" dropdown-toggle style="width: 130px; text-align: left;">
-                    <span class="text-left" style="display: inline-block; width: 85px;">{{curQuickSelection.name}}</span>
+                <button type="button" class="btn btn-default dropdown-toggle" dropdown-toggle style="width: 145px; text-align: left;">
+                    <span class="text-left" style="display: inline-block; width: 100px;">{{curQuickSelection.name}}</span>
                     <span class="glyphicon glyphicon-chevron-down" style="margin-top: 3px;"></span>
                 </button>
                 <ul class="dropdown-menu" role="menu">
                     <li ng-repeat="quickSelection in quickSelectionList">
-                        <a ng-click="changeQuickSelection(quickSelection)">{{quickSelection.name}}</a>
+                        <a class="cursor-pointer" ng-click="changeQuickSelection(quickSelection)">{{quickSelection.name}}</a>
                     </li>
                 </ul>
@@ -50,5 +50,4 @@
     </form>
 </div>
-
 
 <div class="default-view-container">
Index: branches/crossvalidation-2434/HeuristicLab.Services.WebApp.Status/3.3/WebApp/history/historyCtrl.js
===================================================================
--- branches/crossvalidation-2434/HeuristicLab.Services.WebApp.Status/3.3/WebApp/history/historyCtrl.js	(revision 12779)
+++ branches/crossvalidation-2434/HeuristicLab.Services.WebApp.Status/3.3/WebApp/history/historyCtrl.js	(revision 12931)
@@ -2,6 +2,6 @@
     var module = appStatusPlugin.getAngularModule();
     module.controller('app.status.historyCtrl',
-        ['$scope', '$interval', 'app.status.data.service',
-        function ($scope, $interval, dataService) {
+        ['$scope', '$interval', 'app.status.data.service', '$log',
+        function ($scope, $interval, dataService, $log) {
             $scope.chartOptions = {
                 grid: {
@@ -40,5 +40,4 @@
             };
 
-
             $scope.fromDate = new Date();
             $scope.toDate = new Date();
@@ -52,5 +51,7 @@
                 { id: 2, name: 'Yesterday' },
                 { id: 3, name: 'Last 7 Days' },
-                { id: 4, name: 'Last 30 Days' }
+                { id: 4, name: 'Last 30 Days' },
+                { id: 5, name: 'Last 6 Months' },
+                { id: 6, name: 'Last Year' }
             ];
             $scope.changeQuickSelection = function (quickSelection) {
@@ -72,4 +73,18 @@
                     case 4:
                         $scope.fromDate = new Date(today.valueOf() - (30 * oneDayInMs));
+                        $scope.toDate = new Date(today.valueOf());
+                        break;
+                    case 5:
+                        var month = today.getMonth() - 6;
+                        if (month < 0) {
+                            month += 12;
+                        }
+                        $scope.fromDate = new Date(today.valueOf());
+                        $scope.fromDate.setMonth(month);
+                        $scope.toDate = new Date(today.valueOf());
+                        break;
+                    case 6:
+                        $scope.fromDate = new Date(today.valueOf());
+                        $scope.fromDate.setFullYear(today.getFullYear()-1);
                         $scope.toDate = new Date(today.valueOf());
                         break;
@@ -113,9 +128,9 @@
                     for (var i = 0; i < noOfStatus; ++i) {
                         var curStatus = status[i];
-                        var cpuData = Math.round(curStatus.CpuUtilizationStatus.ActiveCpuUtilization);
+                        var cpuData = Math.round(curStatus.CpuUtilizationStatus.TotalCpuUtilization);
                         cpuSeries.push([curStatus.Timestamp, cpuData]);
-                        coreSeries[0].push([curStatus.Timestamp, curStatus.CoreStatus.ActiveCores]);
-                        coreSeries[1].push([curStatus.Timestamp, curStatus.CoreStatus.CalculatingCores]);
-                        memorySeries[0].push([curStatus.Timestamp, Math.round(curStatus.MemoryStatus.ActiveMemory / 1024)]);
+                        coreSeries[0].push([curStatus.Timestamp, curStatus.CoreStatus.TotalCores]);
+                        coreSeries[1].push([curStatus.Timestamp, curStatus.CoreStatus.UsedCores]);
+                        memorySeries[0].push([curStatus.Timestamp, Math.round(curStatus.MemoryStatus.TotalMemory / 1024)]);
                         memorySeries[1].push([curStatus.Timestamp, Math.round(curStatus.MemoryStatus.UsedMemory / 1024)]);
                     }
@@ -129,5 +144,4 @@
                         { data: memorySeries[1], label: "&nbsp;Used Memory", color: "LightPink" }
                     ];
-
                 });
             };
Index: branches/crossvalidation-2434/HeuristicLab.Services.WebApp.Status/3.3/WebApp/status/status.cshtml
===================================================================
--- branches/crossvalidation-2434/HeuristicLab.Services.WebApp.Status/3.3/WebApp/status/status.cshtml	(revision 12779)
+++ branches/crossvalidation-2434/HeuristicLab.Services.WebApp.Status/3.3/WebApp/status/status.cshtml	(revision 12931)
@@ -88,5 +88,5 @@
                     <tr data-toggle="tooltip" data-placement="bottom" title="All calculating slaves that are allowed to calculate">
                         <td class="text-left">Calculating:</td>
-                        <td class="text-right">{{status.MemoryStatus.UsedMemory | kbToGB}} GB</td>
+                        <td class="text-right">{{status.MemoryStatus.CalculatingMemory | kbToGB}} GB</td>
                     </tr>
                 </table>
@@ -115,4 +115,54 @@
                     </tr>
                 </table>
+            </div>
+        </div>
+    </div>
+</div>
+
+<div class="row">
+    <div class="col-lg-12">
+        <div class="panel panel-default">
+            <div class="panel-heading">
+                <h3 class="panel-title">Status Overview</h3>
+            </div>
+            <div class="panel-body">
+                <div class="row">
+                    <div class="col-md-6">
+                        <table class="table table-no-border table-condensed table-auto-width table-content">
+                            <tr>
+                                <td class="text-left">Current Average Waiting Time:</td>
+                                <td class="text-right">{{status.TimeStatus.AvgWaitingTime | toTimespan}}</td>
+                            </tr>
+                            <tr>
+                                <td class="text-left">Total CPU Time:</td>
+                                <td class="text-right">{{status.TimeStatus.TotalCpuTime | toTimespan}}</td>
+                            </tr>
+                            <tr>
+                                <td class="text-left">Since:</td>
+                                <td class="text-right">{{status.TimeStatus.BeginDate | toDate}}</td>
+                            </tr>
+                        </table>
+                    </div>
+                    <div class="col-md-6">
+                        <table class="table table-no-border table-condensed table-auto-width table-content">
+                            <tr>
+                                <td class="text-left">Minimum Calculating Time:</td>
+                                <td class="text-right">{{status.TimeStatus.MinCalculatingTime | toTimespan}}</td>
+                            </tr>
+                            <tr>
+                                <td class="text-left">Maximum Calculating Time:</td>
+                                <td class="text-right">{{status.TimeStatus.MaxCalculatingTime | toTimespan}}</td>
+                            </tr>
+                            <tr>
+                                <td class="text-left">Average Calculating Time:</td>
+                                <td class="text-right">{{status.TimeStatus.AvgCalculatingTime | toTimespan}}</td>
+                            </tr>
+                            <tr>
+                                <td class="text-left">Standard Deviation Calculating Time:</td>
+                                <td class="text-right">{{status.TimeStatus.StandardDeviationCalculatingTime | toTimespan}}</td>
+                            </tr>
+                        </table>
+                    </div>
+                </div>
             </div>
         </div>
Index: branches/crossvalidation-2434/HeuristicLab.Services.WebApp.Status/3.3/WebApp/status/statusCtrl.js
===================================================================
--- branches/crossvalidation-2434/HeuristicLab.Services.WebApp.Status/3.3/WebApp/status/statusCtrl.js	(revision 12779)
+++ branches/crossvalidation-2434/HeuristicLab.Services.WebApp.Status/3.3/WebApp/status/statusCtrl.js	(revision 12931)
@@ -4,5 +4,5 @@
         ['$scope', '$interval', 'app.status.data.service',
         function ($scope, $interval, dataService) {
-            $scope.interval = 10000; // update interval in ms
+            $scope.interval = defaultPageUpdateInterval;
             $scope.knobOptions = {
                 'fgColor': "#f7921d",
@@ -103,5 +103,5 @@
                     $scope.cpu.knobData = Math.round(status.CpuUtilizationStatus.ActiveCpuUtilization);
                     $scope.core.knobData = Math.round(status.CoreStatus.CalculatingCores / status.CoreStatus.ActiveCores * 100);
-                    $scope.memory.knobData = Math.round(status.MemoryStatus.UsedMemory / status.MemoryStatus.ActiveMemory * 100);
+                    $scope.memory.knobData = Math.round(status.MemoryStatus.CalculatingMemory / status.MemoryStatus.ActiveMemory * 100);
                     // chart series
                     var cpuSeries = $scope.cpu.series[0].data.splice(0);
@@ -127,13 +127,8 @@
                     
                     cpuSeries.push([$scope.status.Timestamp, Math.round(status.CpuUtilizationStatus.TotalCpuUtilization)]);
-                    // charts are currently filled with old total/used data
-                    // start temporary
-                    var usedCores = status.CoreStatus.TotalCores - status.CoreStatus.FreeCores;
-                    var usedMemory = status.MemoryStatus.TotalMemory - status.MemoryStatus.FreeMemory;
-                    // end temporary
                     coreSeries[0].push([$scope.status.Timestamp, status.CoreStatus.TotalCores]);
-                    coreSeries[1].push([$scope.status.Timestamp, usedCores]);
+                    coreSeries[1].push([$scope.status.Timestamp, status.CoreStatus.UsedCores]);
                     memorySeries[0].push([$scope.status.Timestamp, Math.round(status.MemoryStatus.TotalMemory / 1024)]);
-                    memorySeries[1].push([$scope.status.Timestamp, Math.round(usedMemory / 1024)]);
+                    memorySeries[1].push([$scope.status.Timestamp, Math.round(status.MemoryStatus.UsedMemory / 1024)]);
                     $scope.cpu.series = [{ data: cpuSeries, label: "&nbsp;CPU Utilization", color: "#f7921d" }];
                     $scope.core.series = [
@@ -160,9 +155,9 @@
                     for (var i = 0; i < noOfStatus; ++i) {
                         var curStatus = status[i];
-                        var cpuData = Math.round(curStatus.CpuUtilizationStatus.ActiveCpuUtilization);
+                        var cpuData = Math.round(curStatus.CpuUtilizationStatus.TotalCpuUtilization);
                         cpuSeries.push([curStatus.Timestamp, cpuData]);
-                        coreSeries[0].push([curStatus.Timestamp, curStatus.CoreStatus.ActiveCores]);
-                        coreSeries[1].push([curStatus.Timestamp, curStatus.CoreStatus.CalculatingCores]);
-                        memorySeries[0].push([curStatus.Timestamp, Math.round(curStatus.MemoryStatus.ActiveMemory / 1024)]);
+                        coreSeries[0].push([curStatus.Timestamp, curStatus.CoreStatus.TotalCores]);
+                        coreSeries[1].push([curStatus.Timestamp, curStatus.CoreStatus.UsedCores]);
+                        memorySeries[0].push([curStatus.Timestamp, Math.round(curStatus.MemoryStatus.TotalMemory / 1024)]);
                         memorySeries[1].push([curStatus.Timestamp, Math.round(curStatus.MemoryStatus.UsedMemory / 1024)]);
                     }